`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    12:38:31 10/12/2016 
// Design Name: 
// Module Name:    vending 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module vending(
    input clk,
    input reset,
    input s5,
    input s10,
    input s25,
    input s100,
    input btnc,
    input btndc,
    input btndp,
    input btns,
    output [7:0] m,
    output [7:0] c,
    output relq,
    output reld,
    output reln,
    output relc,
    output reldc,
    output reldp,
    output rels,
	 output qcollect,
	 output qrelease,
	 output qinitc,
    output qchange
    );

	wire loadm, mge100, bp, ren;
	wire [1:0] mmux_sel;
	wire [7:0] m_d, msnum;

	vending_fsm fsm(
    .clk(clk),
    .reset(reset),
    .mge100(mge100),
    .bp(bp),
    .ceq0(ceq0),
    .ren(ren),
	 .qcollect(qcollect),
	 .qrelease(qrelease),
	 .qinitc(qinitc),
    .qchange(qchange)
    );

	// Partially complete datapath
	//   Map/draw out what we've given and look for signals
	//   you will still need to produce.  Then add all the other
	//   datapath components you need.
	
   adder8 money_adder(	.A(m),
								.B(msnum),
								.C0(1'b0),
								.S(m_d),
								.C8());
								
	pe4_2 enc(  .I0(s5),
					.I1(s10),
					.I2(s25),
					.I3(s100),
					.Y(mmux_sel),
					.V(loadm) );

	moneymux mmux1( .S(mmux_sel),
						 .MONEY( msnum )
						 );
	
	
	reg8e mreg( .clk(clk),
					.reset(mreset),
					.en(loadm),
					.d(m_d),
					.q(m) );


	
endmodule
